/*
 * Proyecto: FileDownload
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 14/01/2018
 */

#include "Xailer.ch"

CLASS TForm1 FROM TForm

   COMPONENT oButton1
   COMPONENT oLabel1
   COMPONENT oAsynFileDownload1

   PROPERTY nLength  INIT 0

   METHOD CreateForm()
   METHOD AsynFileDownload1Disconnect( oSender )
   METHOD AsynFileDownload1Error( oSender, cError )
   METHOD AsynFileDownload1TotalDnLoadInfo( oSender, nProgress )
   METHOD AsynFileDownload1TotalLengthInfo( oSender, nTotal )
   METHOD Button1Click( oSender )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

METHOD AsynFileDownload1Disconnect( oSender ) CLASS TForm1

   ::oLabel1:cText := "Archivo descargado"

RETURN Nil

//------------------------------------------------------------------------------

METHOD AsynFileDownload1Error( oSender, cError ) CLASS TForm1

   ::oLabel1:cText := "Error: " + cError

RETURN Nil

//------------------------------------------------------------------------------

METHOD AsynFileDownload1TotalDnLoadInfo( oSender, nProgress ) CLASS TForm1

   ::oLabel1:cText := "Descargados " + LTrim( Transform( nProgress, "@E 999,999,999" ) ) + " bytes"
   IF !Empty( ::nLength )
      ::oLabel1:cText += " de " + LTrim( Transform( ::nLength, "@E 999,999,999" ) )
   ENDIF

RETURN Nil

//------------------------------------------------------------------------------

METHOD AsynFileDownload1TotalLengthInfo( oSender, nTotal ) CLASS TForm1

   ::nLength := nTotal

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button1Click( oSender ) CLASS TForm1

   WITH OBJECT ::oAsynFileDownload1
      :cLocalFile := Application:cDirectory + "\Prueba.zip"
      :cRemoteFile := "https://drive.google.com/uc?export=download&id=151DYvK_Nvi1jdv9j6SnTXHE4OsASVRv6"
      :Run()
   END

RETURN Nil

//------------------------------------------------------------------------------
